import random
win = []
xx = 21
yy = 17
ship = [["*","*","▲","*","*"],["╘","[","█","]","╛"],["*","∩","■","∩","*"]]
enemy = [["╲","█","╱"],["*","▼","*"]]
shot = [["┇"]]
sp = xx//2-len(ship[0])//2+1
names = []
points = []
#══════════════════════════════════════════════════════ вывод поля
def pr():
    print(("    ╔═════════════════════╗"))
    for y in range(yy):
        print("    ║", end='')
        for x in range(xx):
            print(win[x][yy-1-y], end='')
        print("║")
    print("    ╚═════════════════════╝")
    
    for y in range(yy):
        for x in range(xx):
            if y == 2:
                win[x][y] = "―"
            else:
                win[x][y] = " "
#══════════════════════════════════════════════════════ совмещение 2 слоев
def motion(s, ss, x1, y1):
        for x in range(len(ss[0])):
            for y in range(len(ss)):
                if(x1+x-1<xx and yy-y-y1<yy) and ss[y][x]!="*":
                    s[x+x1-1][yy-y-y1] = ss[y][x]
#══════════════════════════════════════════════════════ совмещение слоев поля
def merge_layers():
    motion(win, ship, sp, yy-2)
    for q in opponents:
        q.draw(win)
    for q in bullets:
        q.draw(win)
#══════════════════════════════════════════════════════ пули       
class shooting():
    def __init__(self, x, y):
        self.x = x
        self.y = y 
    def draw(self, win):
        motion(win, shot, self.x, self.y)
#══════════════════════════════════════════════════════ враги
class opponent():
    def __init__(self, x, y):
        self.x = x
        self.y = y
    def draw(self, win):
        motion(win, enemy, self.x, self.y)  
#══════════════════════════════════════════════════════ управление
print("╔═════════════════════════════╗")
print("║     Пошагавая стратегия     ║")
print("║         Управление:         ║")
print("║a - движение влево           ║")
print("║d - движение вправо          ║")
print("║q - стрельба из левой пушки  ║")
print("║e - стрельба из правой пушки ║")
print("║s - пропустить ход           ║")
print("╚═════════════════════════════╝")
#══════════════════════════════════════════════════════ основной цикл игры
the_first_game = True
the_game_is_running = True
while the_game_is_running:
    #══════════════════════════════════════════════════════ переменные/ввод ника
    win = []
    sp = xx//2-len(ship[0])//2+1
    opponents = []
    bullets = []
    chance_of_occurrence = 5
    health = 1
    experience_points = 0
    complexity = 5
    for x in range(xx):
        win.append([])
        for y in range(yy):
            win[x].append(" ")
    for x in range(xx):
        win[x][2] = "―"
    correct_nickname = True
    while correct_nickname:
        print("╔═════════════════════════════╗")
        print("║ Введите имя игрока(до 8 б.) ║")
        print("╚═════════════════════════════╝")
        new_name = input()
        if len(new_name)< 9:
            correct_nickname = False
    motion(win, ship, sp, yy-2)        
    pr()
    #══════════════════════════════════════════════════════ сама игра
    game = True
    while game:
        #══════════════════════════════════════════════════════ движение кораблика
        action = True
        while action:
            button = input()
            if button == "a" or button == "ф":
                action = False
                sp -= 1
            elif button == "d" or button == "в":
                action = False
                sp += 1
            elif button == "s" or button == "ы":
                action = False
            elif button == "q" or button == "й":
                if len(bullets) < 20 :
                    bullets.append(shooting(round(sp),round(yy-1)))
                action = False
            elif button == "e" or button == "у":
                if len(bullets) < 20 :
                    bullets.append(shooting(round(sp+len(ship[0])-1),round(yy-1)))
                action = False
        #══════════════════════════════════════════════════════ движение пуль/проверка столкновения         
        for bullet in bullets:
            bullet.y -= 1
            for q in opponents:
                if q.y+len(enemy)+1 > bullet.y and bullet.x >= q.x and bullet.x <= q.x + len(enemy[0]):
                    opponents.pop(opponents.index(q))
                    experience_points += 10
                    bullets.pop(bullets.index(bullet))
        #══════════════════════════════════════════════════════ движение врагов
        for q in opponents:
            q.y += 1
            if q.y > yy-3:
                health -= 1
                opponents.pop(opponents.index(q))
        #══════════════════════════════════════════════════════ сложность
        if (experience_points > 150):
            complexity = 4
            if (experience_points > 300):
                complexity = 3
        #══════════════════════════════════════════════════════ появление врагов
        if (random.randint(chance_of_occurrence, complexity) == complexity):
            opponents.append(opponent(round(random.randint(1,19)),round(0)))
            chance_of_occurrence = 0
        else:
            chance_of_occurrence += 1
        #════   
        merge_layers()
        #════
        if health == 0:
            #══════════════════════════════════════════════════════ проигрыш/изменения топа
            performance = 1
            if the_first_game:
                names.append(new_name)
                points.append(experience_points)
                the_first_game = False
            else:
                if experience_points <= points[len(points)-1]:
                    names.append(new_name)
                    points.append(experience_points)
                else:
                    names.append(names[len(names)-1])
                    points.append(points[len(points)-1])
                    if experience_points > points[0]:
                        for i in range(len(points)-1):
                            points[len(points)-1-i] = points[len(points)-2-i]    
                            names[len(names)-1-i] = names[len(names)-2-i]
                        points[0] = experience_points
                        names[0] = new_name
                    else:
                        for i in range(len(points)):
                            if performance == 1:
                                if experience_points > points[len(points)-2-i]:
                                    points[len(points)-1-i] = points[len(points)-2-i]
                                    names[len(names)-1-i] = names[len(names)-2-i]
                                else:
                                    points[len(points)-1-i] = experience_points
                                    names[len(names)-1-i] = new_name
                                    performance = 0
            #══════════════════════════════════════════════════════ вывод топа
            print()
            print("              top              ")
            for i in range(len(names)):
                print("    ",i+1,names[i], end='')
                for sg in range(10-len(names[i])):
                    print(" ", end='')
                print(points[i])                
            game = False
            #══════════════════════════════════════════════════════ окончание игры
            print()
            print("╔═════════════════════════════╗")
            print("║   начать с начала?  (1/0)   ║")
            print("╚═════════════════════════════╝")
            finish_the_game = True
            while finish_the_game:
                answer = input()
                if answer == "0":
                    the_game_is_running = False
                    finish_the_game = False
                elif answer == "1":
                    finish_the_game = False
        else:
            pr()
